﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;

namespace RadComboBoxProblem
{
	public partial class MainPage : UserControl
	{
		public MainPage()
        {
            var vm = new ViewModel();
            vm.Items.Add(new DataItem { Name = "One", Value = 2342 });
            vm.Items.Add(new DataItem { Name = "Two", Value = 78746 });
            vm.Items.Add(new DataItem { Name = "Three", Value = 3862867 });
            vm.Items.Add(new DataItem { Name = "Four", Value = 282876 });
            vm.Items.Add(new DataItem { Name = "Five", Value = 2389276 });
 
            DataContext = vm;
            InitializeComponent();
        }
 
        private void Button_Click(object sender, RoutedEventArgs e)
        {           
            var vm = (ViewModel)DataContext;
            vm.DoItemUpdate();
        }
    }
 
    public class ViewModel : INotifyPropertyChanged
    {  
        private readonly ObservableCollection<DataItem> _items = new ObservableCollection<DataItem>();
        public ObservableCollection<DataItem> Items
        {
            get { return _items; }
        }
 
        private DataItem _selectedItem;
        public DataItem SelectedItem
        {
            get { return _selectedItem; }
            set
            {
                if (_selectedItem != value)
                {
                    _selectedItem = value;
                    PropertyChanged(this, new PropertyChangedEventArgs("SelectedItem"));
                }
            }
        }
 
        public event PropertyChangedEventHandler PropertyChanged;
 
        public void DoItemUpdate()
        {
            Items[2].Name = "AAARGH";
			
        }
    }
 
    public class DataItem : ViewModelBase
    {
		private string _name;
		private object _value;

        public string Name {
			get { return _name; }
			set
			{
				if (_name != value)
				{
					_name = value;
					this.OnPropertyChanged("Name");
				}
			}
		}
 
        public object Value
		{
			get { return _value; }
			set
			{
				if (_value != value)
				{
					_value = value;
					this.OnPropertyChanged("Value");
				}
			}
		}
    }

}
